'
' -----------------------------------------------------------------------------
' Usefull Window Tools                            May 5th, 2007         Jacques
' -----------------------------------------------------------------------------
'
''pre cmd tiny noenc run opt exe nocon kill nobk diricon upx
''pre end
'
$Include "QWindowTools.Inc"
Dim myWndTools As QWindowTools
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
Declare Sub OnClose_frmWindowUtil
Declare Sub OnClic_btnAny (Sender As QButton)
Declare Sub OnKeyDown_edtAny (Key As Long, Shift As Long, Sender As QEdit)
'
Declare Sub OnResize_frmWindowUtil
'
Create frmWindowUtil As QForm
    Center
    Width = 2 * Screen.Width/3
    height = 800
    Caption = "Windows Util: Child List, Child Handle, Parent Handle, ClassName, WindowText"
    AutoScroll = False
    OnClose = OnClose_frmWindowUtil
    Create pnlTop As QPanel
        Height = 5 + 7 * 33
        Color = &H3C1A6F
        Font.Color = &H980C0F
        Font.Size = 12
        Font.Name = "Courier"
        Align = alTop
        Create btnClearRichEdit As QButton
            Left = 5
            Top = 5 + 6 * 33
            Width = 230
            Height = 30
            Font.Color = &H0000C0
            Font.Bold = True
            Caption = "&Clear RichEdit"
            OnClick = OnClic_btnAny
        End Create
        Create btnSearchCase As QButton
            Left = 238
            Top = 5 + 6 * 33
            Width = 400
            Height = 30
            Font.Color = &H107700
            Font.Bold = True
            Caption = "&Search IS NOT Case Sensitive"
            OnClick = OnClic_btnAny
        End Create
        Create btnApocalypse As QButton
            Left = 640
            Top = 5 + 6 * 33
            Height = 30
            Font.Color = &H0000C0
            Font.Bold = True
            Caption = "Free Apocalypse Test"
            OnClick = OnClic_btnAny
        End Create
    End Create
    Create rchWin AS QRichEdit
        Align = 5
        Font.Name = "courier" ' "courier new"
        Font.Size = 8 ' 12
        Font.Color = &H800000
        ' Font.Bold = True
        Color = &HE6F7FF
        ReadOnly = True
        WordWrap = False
        ScrollBars = ssBoth
        HideSelection = False
        PlainText = True
    End Create
End Create
'
' --------------------------------------------------------------------
' New Code API Call that lets RapidQ programs minimize to the task bar
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG, _
                                               nIndex AS LONG, dwNewLong AS LONG) AS LONG
'      ----- API Constants and Functions
CONST GWL_HWNDPARENT = (-8)                   'Minimize to task bar
CONST HWND_DESKTOP = 0
setwindowlong(frmWindowUtil.handle, GWL_HWNDPARENT, HWND_DESKTOP)
setwindowlong(application.handle, GWL_HWNDPARENT, frmWindowUtil.handle)
' --------------------------------------------------------------------
'
DefInt flagButtonBusy = False
'
DefInt n
Dim btnFunc(1 To 8) As QButton
Dim edtFunc(1 To 6) As QEdit
'
For n = 1 To 6
    btnFunc(n).Parent = pnlTop
    btnFunc(n).Left = 5
    btnFunc(n).Top = 5 + (n - 1) * 33
    btnFunc(n).Width = 600
    btnFunc(n).Height = 30
    btnFunc(n).Font.Bold = True
    btnFunc(n).OnClick = OnClic_btnAny
'
    edtFunc(n).Parent = pnlTop
    edtFunc(n).Left = 608
    edtFunc(n).Top = 5 + (n - 1) * 33
    edtFunc(n).Height = 30
    edtFunc(n).ShowHint = True
    edtFunc(n).Tag = n
    edtFunc(n).OnKeyDown = OnKeyDown_edtAny
Next n
'
Const CLASSNAME  = 1
Const WINDOWTEXT = 2
Const LIST_ALL_WINDOWS = 3
Const LIST_ALL_CHILDS = 4
Const SEARCH_IN_CLASSNAME = 5
Const SEARCH_IN_WINDOWTEXT = 6
'
btnFunc(CLASSNAME).Caption            = "Get CLassName          for Window Handle:"
btnFunc(WINDOWTEXT).Caption           = "Get WindowText         for Window Handle:"
btnFunc(LIST_ALL_WINDOWS).Caption     = "List All Windows                         "
btnFunc(LIST_ALL_CHILDS).Caption      = "List All Child Windows for Parent Handle:"
btnFunc(SEARCH_IN_CLASSNAME).Caption  = "Search ClassNames               for text:"
btnFunc(SEARCH_IN_WINDOWTEXT).Caption = "Search WindowTexts              for text:"
'
edtFunc(LIST_ALL_WINDOWS).Visible = False
'
edtFunc(CLASSNAME).Hint            = "Enter the Handle of the Window\nfrom which you want to get the ClassName"
edtFunc(CLASSNAME).Text            = "140"
edtFunc(WINDOWTEXT).Hint           = "Enter the Handle of the Window\nfrom which you want to get the WindowText"
edtFunc(WINDOWTEXT).Text           = "140"
edtFunc(LIST_ALL_CHILDS).Hint      = "Enter the Handle of the Parent Window\nfrom which you want to get all the Child Windows"
edtFunc(LIST_ALL_CHILDS).Text      = "140"
edtFunc(SEARCH_IN_CLASSNAME).Hint  = "Enter the Text To Find in Classnames of all existing windows"
edtFunc(SEARCH_IN_CLASSNAME).Text  = "ToolTips"
edtFunc(SEARCH_IN_WINDOWTEXT).Hint = "Enter the Text To Find in WindowText of all existing windows"
edtFunc(SEARCH_IN_WINDOWTEXT).Text = "Explo"
'
frmWindowUtil.OnResize = OnResize_frmWindowUtil
'
' *************************************
frmWindowUtil.Visible = False
frmWindowUtil.ShowModal
' *************************************
'
Sub OnResize_frmWindowUtil
    DefInt n
    For n = 1 To 6
        edtFunc(n).Width = frmWindowUtil.ClientWidth - 612
    Next n
    btnApocalypse.Width = frmWindowUtil.ClientWidth - 643
End Sub
'
Sub OnClose_frmWindowUtil
    Application.Terminate
End Sub
'
Sub OnClic_btnAny (Sender As QButton)
    DefStr sTmp, sResult
    DefInt i
    '
    If flagButtonBusy = True Then Exit Sub
    flagButtonBusy = True
    '
    If btnSearchCase.Caption = "&Search IS NOT Case Sensitive" Then
        myWndTools.SearchCaseSensitive = False
    Else
        myWndTools.SearchCaseSensitive = True
    End If
    '
    Select Case Sender.Handle
        Case btnFunc(CLASSNAME).Handle
            sTmp = " CLASSNAME OF WINDOW \"" & edtFunc(CLASSNAME).text & "\" ----"
            sResult = myWndTools.GetClassName (Val(edtFunc(CLASSNAME).text))
            If sResult = "" Then sResult = "None ClassName Found"
            rchWin.text = rchWin.Text _
                & "\n\n----" & sTmp & "\n" & String$(Len(sTmp) + 4, "-") & "\n" & sResult
            rchWin.Addstring ("---- END OF" & sTmp)

        Case btnFunc(WINDOWTEXT).Handle
            sTmp = " WINDOWTEXT OF WINDOW \"" & edtFunc(WINDOWTEXT).text & "\" ----"
            sResult = myWndTools.GetWindowText (Val(edtFunc(WINDOWTEXT).text))
            If sResult = "" Then sResult = "None WindowText Found"
            rchWin.text = rchWin.Text _
                & "\n\n----" & sTmp & "\n" & String$(Len(sTmp) + 4, "-") & "\n" & sResult
            rchWin.Addstring ("---- END OF" & sTmp)

        Case btnFunc(LIST_ALL_WINDOWS).Handle
            myWndTools.GetChildsList (0)
            sResult = myWndTools.Result
            If sResult = "" Then sResult = "No Window Found(Should never Happen ;)"
            rchWin.text = rchWin.Text _
                & "\n\n---- LIST OF ALL WINDOWS ----" & "\n-----------------------------\n" _
                & ReplaceSubStr$(sResult, Chr$(0), "_")
            rchWin.AddString "---- END OF ALL WINDOWS LIST ----"

        Case btnFunc(LIST_ALL_CHILDS).Handle
            myWndTools.GetChildsList (Val(edtFunc(LIST_ALL_CHILDS).text))
            sResult = myWndTools.Result
            If sResult = "" Then sResult = "No Child Window Found"

            sTmp = " LIST ALL CHILD WINDOWS OF \"" & edtFunc(LIST_ALL_CHILDS).text & "\" ----"
            rchWin.text = rchWin.Text _
                & "\n\n----" & sTmp & "\n" & String$(Len(sTmp) + 4, "-") _
                & "\n" & ReplaceSubStr$ (sResult, Chr$(0), "_")
            rchWin.Addstring ("---- END OF" & sTmp)

        Case btnFunc(SEARCH_IN_CLASSNAME).Handle
            sTmp = " SEARCH IN CLASSNAMES FOR \"" & edtFunc(SEARCH_IN_CLASSNAME).text & "\" ----"
            rchWin.text = rchWin.Text _
                & "\n\n----" & sTmp & "\n" & String$(Len(sTmp) + 4, "-")
            myWndTools.SearchInClassNames (edtFunc(SEARCH_IN_CLASSNAME).text)
            For i = 0 To myWndTools.lstFound.ItemCount - 1
                rchWin.AddString ReplaceSubStr$ (myWndTools.lstFound.Item(i), Chr$(0), "_")
                myWndTools.DecodeFoundItem (myWndTools.lstFound.Item(i))
                rchWin.AddString "                myHandle: " & Str$(myWndTools.ChildHandle)
                rchWin.AddString "          myParentHandle: " & Str$(myWndTools.ParentHandle)
                rchWin.AddString "             myClassName: " & myWndTools.ChildClassName
                rchWin.AddString "            myWindowText: " & myWndTools.ChildWindowText
            Next i
            If myWndTools.lstFound.ItemCount = 0 Then rchWin.AddString "No Item Found"
            rchWin.Addstring ("---- END OF" & sTmp)

        Case btnFunc(SEARCH_IN_WINDOWTEXT).Handle
            sTmp = " SEARCH IN WINDOWTEXTS FOR \"" & edtFunc(SEARCH_IN_WINDOWTEXT).text & "\" ----"
            rchWin.text = rchWin.Text _
                & "\n\n----" & sTmp & "\n" & String$(Len(sTmp) + 4, "-")
            myWndTools.SearchInWindowTexts (edtFunc(SEARCH_IN_WINDOWTEXT).text)
            For i = 0 To myWndTools.lstFound.ItemCount - 1
                rchWin.AddString ReplaceSubStr$ (myWndTools.lstFound.Item(i), Chr$(0), "_")
                myWndTools.DecodeFoundItem (myWndTools.lstFound.Item(i))
                rchWin.AddString "                myHandle: " & Str$(myWndTools.ChildHandle)
                rchWin.AddString "          myParentHandle: " & Str$(myWndTools.ParentHandle)
                rchWin.AddString "             myClassName: " & myWndTools.ChildClassName
                rchWin.AddString "            myWindowText: " & myWndTools.ChildWindowText
            Next i
            If myWndTools.lstFound.ItemCount = 0 Then rchWin.AddString "No Item Found"
            rchWin.Addstring ("---- END OF" & sTmp)

        Case btnClearRichEdit.Handle
            rchWin.Clear

        Case btnSearchCase.Handle
            If btnSearchCase.Caption = "&Search IS NOT Case Sensitive" Then
                btnSearchCase.Caption = "&Search IS Case Sensitive"
            Else
                btnSearchCase.Caption = "&Search IS NOT Case Sensitive"
            End If

        Case btnApocalypse.Handle
            ShowMessage ("Under Construction")

    End Select
    flagButtonBusy = False
End Sub
'
Sub OnKeyDown_edtAny (Key As Long, Shift As Long, Sender As QEdit)
    ' If CR Pressed
    If Key = &H0D Then OnClic_btnAny (btnFunc(Sender.Tag))
End Sub
' -----------------------------------------------------------------------------
'
